#include<bits/stdc++.h>
#define ll long long

using namespace std;

int n,t;
int dp[1010][1010];
bool mark[1010][1010];
int predak[1010];
int duzina[1010];
ll lep[1010];

ll resi(int cvor, int vreme)
{
    if(vreme<predak[cvor])
        return lep[cvor];
    if(mark[cvor][vreme])
        return dp[cvor][vreme];
    mark[cvor][vreme]=true;
    return lep[cvor]+resi(predak[cvor],vreme-duzina[cvor]);
}



int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);

    cin>>n>>t;

    for(int i=1;i<=n;i++)
        cin>>lep[i];

    for(int i=1;i<=n;i++)
        cin>>predak[i];

    for(int i=1;i<=n;i++)
        cin>>duzina[i];

    ll sol=-1;
    for(int i=1;i<=n;i++)
        sol=max(sol,resi(i,t));
    cout<<sol;
    return 0;
}